unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, ADODB, OleServer, Word2000, WordXP;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    ADODataSet1: TADODataSet;
    Button1: TButton;
    W1: TWordApplication;
    Button2: TButton;
    StatusLabel: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure TableExport(DataSet:TDataSet; Title, FlagText:string);
    Procedure TableLineSet;
    procedure WInit;
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses ComObj;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
 vr:olevariant;
begin
 try
  statusLabel.Caption:='  ';
  winit;
  w1.Connect;
  //w1.Visible:=true;
  vr:=GetCurrentDir+'\Shablon.doc';
  W1.Documents.Open(vr,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
  //  
  vr:='Text Box 8';
  w1.ActiveDocument.Shapes.Item(vr).Select(EmptyParam);
  //  
  w1.Selection.TypeText('  ');
  //   
  vr:=wdStory;
  w1.Selection.EndKey(vr,EmptyParam);
  { if-   }
  //   
  w1.ActiveWindow.ActivePane.View.SeekView:=wdSeekCurrentPageHeader;
  vr:='Text Box 5';
  w1.Selection.HeaderFooter.Shapes.Item(vr).Select(EmptyParam);
  w1.Selection.TypeText('  ');
  w1.ActiveWindow.ActivePane.View.SeekView:=wdSeekMainDocument;
  ADODataSet1.Close;
  ADODataSet1.CommandText:='SELECT [Main].[Tel], '+
                                  '[Main].[name], '+
                                  '[Main].[House], '+
                                  '[Korp].[NameKorp], '+
                                  '[Flat].[NameFlat], '+
                                  '[Ul].[NameUl] '+
   ' FROM Main, Ul, Korp, Flat '+
   ' WHERE ([Main].[IdUl]=[Ul].[IdUl]) And ([Main].[IdKorp]=[Korp].[IdKorp]) And ([Main].[IdFlat]=[Flat].[IdFlat]) ';
  ADODataSet1.Open;
  // 
  {WFTitle.Size:=15;
  WFTitle.Bold:=1;
  WFTableTitle.Size:=13;
  WFtext.Size:=10;}
  //  
  ADODataSet1.fields[0].DisplayLabel:=''; //
  ADODataSet1.fields[0].tag:=round(w1.CentimetersToPoints(2)); // 
  ADODataSet1.fields[0].Visible:=true;// 
  ADODataSet1.fields[1].DisplayLabel:=''; //
  ADODataSet1.fields[1].tag:=round(w1.CentimetersToPoints(10)); // 
  ADODataSet1.fields[1].Visible:=true;// 
  ADODataSet1.fields[2].DisplayLabel:=''; //
  ADODataSet1.fields[2].tag:=round(w1.CentimetersToPoints(1.5)); // 
  ADODataSet1.fields[2].Visible:=true;// 
  ADODataSet1.fields[3].DisplayLabel:=''; //
  ADODataSet1.fields[3].tag:=round(w1.CentimetersToPoints(1.5)); // 
  ADODataSet1.fields[3].Visible:=true;// 
  ADODataSet1.fields[4].DisplayLabel:=''; //
  ADODataSet1.fields[4].tag:=round(w1.CentimetersToPoints(1.5)); // 
  ADODataSet1.fields[4].Visible:=true;// 
  ADODataSet1.fields[5].Visible:=false;//  
  //  
  TableExport(ADODataSet1,'   ','');
  TableExport(ADODataSet1,'   ','');
  // .      , 
  //   
  w1.Visible:=true;
  w1.Disconnect;
  statusLabel.Caption:='';
 except
  on e:exception do
   begin
    w1.Visible:=true;
    statusLabel.Caption:='   ';
    w1.Disconnect;
    raise Exception.Create('  .'+#13+e.Message);
   end;
 end;
end;

procedure TForm1.TableExport(DataSet:TDataSet; Title, FlagText:string);
var
 i,ColCount,  //   
 TableBeg,     //    
 TableBeg2: integer;     //     
 vr1,vr2: OleVariant;
 f: boolean;
 st: string;

function ConvertString(S:string):string;
 {,    ,    .  
        "-", 
     .     
   .    ,  
  "-"     #173,    -}
begin
 Result := StringReplace(S, '-', #173,[]);
end;

begin
 {     ,  
      FlagText
  FlagText=''    .
    ,      
  ,     }


  Application.ProcessMessages;
  vr1:=wdStory;
  w1.Selection.EndKey(vr1,EmptyParam); //   
  //  
  W1.ActiveDocument.Range(EmptyParam,EmptyParam).InsertAfter(Title);
  //  , -      
  //   
  W1.ActiveDocument.Paragraphs.Item(w1.ActiveDocument.Paragraphs.Count).Range.Select;
  W1.Selection.ParagraphFormat.KeepWithNext:=-1;
  W1.Selection.ParagraphFormat.SpaceAfter:=14;
  W1.Selection.Font.Size:=15;         // 
  W1.Selection.Font.bold:=1;
  W1.ActiveDocument.Paragraphs.Add(EmptyParam); // 
                                                // 
  W1.ActiveDocument.Paragraphs.Item(w1.ActiveDocument.Paragraphs.Count).Range.Select;
  W1.Selection.ParagraphFormat.SpaceAfter:=0;
  vr1:=wdStory;
  w1.Selection.EndKey(vr1,EmptyParam); //   
  //  .  -   .
  //    , -    
  //     "  "   
  TableBeg:=W1.Selection.End_;
  DataSet.First;
  //     
  for i:=0 to DataSet.FieldCount-1 do
   if DataSet.Fields[i].Visible
   then W1.ActiveDocument.Range(EmptyParam,EmptyParam).InsertAfter(convertstring(DataSet.Fields[i].DisplayLabel)+#9);
  Application.ProcessMessages;
  w1.Selection.EndKey(vr1,EmptyParam);
  //   
  {         }
  w1.Selection.TypeBackspace;
  // 
  W1.ActiveDocument.Paragraphs.Item(w1.ActiveDocument.Paragraphs.Count).Range.Select;
  W1.Selection.Font.Size:=14;
  W1.Selection.Font.Italic:=1;
  W1.Selection.Font.bold:=0;

  // 
  W1.ActiveDocument.Paragraphs.Add(EmptyParam);
  f:=true;//  ,        
  st:=''; //      
  TableBeg2:=W1.Selection.End_;   //   

  if dataset.RecordCount>0
  then
   begin
    Repeat
     Application.ProcessMessages;
     if (dataset.fields[DataSet.Fields.Count-1].AsString=FlagText) or (FlagText='')
      then
      begin
        for i:=0 to DataSet.FieldCount-1 do
           if DataSet.Fields[i].Visible
           then st:=st+DataSet.Fields[i].AsString+#9; //     
        SetLength(st,length(st)-1);                  //   
        st:=st+#13;                                  // 
        f:=false;
      end;
    dataset.Next;
    until dataset.Eof;
    w1.Selection.EndKey(vr1,EmptyParam);//   
    W1.Selection.InsertAfter(convertstring(st));       //  
    vr1:=TableBeg2;                     //  
    vr2:=W1.Selection.End_;             // 
    W1.Selection.Font.Size:=12;
    W1.Selection.Font.bold:=0;
    W1.Selection.Font.Italic:=0;
   end;
  //  ,      
  //  
  if f then
   begin
    for i:=0 to DataSet.FieldCount-1 do
      if DataSet.Fields[i].Visible then
        W1.ActiveDocument.Range(EmptyParam,EmptyParam).InsertAfter(' '+#9);
    w1.Selection.EndKey(vr1,EmptyParam);
    w1.Selection.TypeBackspace;
   end;
  Application.ProcessMessages;
  vr1:=TableBeg;//  
  vr2:=W1.Selection.End_;//  
  W1.ActiveDocument.Range(vr1,vr2).Select;//  
  //    
  W1.Selection.ConvertToTable(EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam);
  colcount:=1;
 //  
    for i:=0 to DataSet.FieldCount-1 do
      if DataSet.Fields[i].Visible
      then
       begin
        W1.ActiveDocument.Tables.Item(W1.ActiveDocument.Tables.Count).Columns.Item(colcount).Width:=DataSet.Fields[i].Tag;
        inc(colcount);
        Application.ProcessMessages;
       end;
  TableLineSet; //     
  W1.ActiveDocument.Paragraphs.Add(EmptyParam);
  W1.ActiveDocument.Paragraphs.Item(w1.ActiveDocument.Paragraphs.Count-1).Range.Select;
  W1.Selection.ParagraphFormat.KeepWithNext:=0;
end;

procedure TForm1.TableLineSet; //    
begin
 w1.Selection.Cells.Borders.Item(wdBorderLeft).LineStyle:=wdLineStyleSingle;
 w1.Selection.Cells.Borders.Item(wdBorderRight).LineStyle:= wdLineStyleSingle;
 w1.Selection.Cells.Borders.Item(wdBorderHorizontal).LineStyle:= wdLineStyleSingle;
 w1.Selection.Cells.Borders.Item(wdBorderTop).LineStyle:= wdLineStyleSingle;
 w1.Selection.Cells.Borders.Item(wdBorderBottom).LineStyle:= wdLineStyleSingle;
 w1.Selection.Cells.Borders.Item(wdBorderVertical).LineStyle:= wdLineStyleSingle;
end;

procedure TForm1.WInit;
begin
 //      
 //    ...
 W1.free;
 W1:=TWordApplication.Create(Form1);
 w1.connectkind:=ckNewInstance;//     
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 vr1,vr2,vr3,vr4,vr5: OleVariant;
begin
 vr1:=0;
 vr2:=false;
 vr3:='Provider=Microsoft.Jet.OLEDB.4.0;Password="""";User ID=Admin;Data Source=C:\Dataware\Deplhi7\ \db1.mdb;Mode=Read;Extended Properties="""";Jet OLEDB:System database="""";Jet OLEDB:Database Password="""";Jet OLEDB:Engine Type=5;';
 vr4:='SELECT ,  FROM QMain ORDER BY ';
 vr5:=GetCurrentDir+'\db1.mdb';
 winit;
 try
  w1.Connect;
  w1.Documents.Add(EmptyParam,EmptyParam,EmptyParam,EmptyParam);
  w1.Visible:=true;
  w1.Selection.Range.InsertDatabase(vr1,vr1,vr2,vr3,vr4,EmptyParam,EmptyParam,EmptyParam,EmptyParam,EmptyParam,vr5,EmptyParam,EmptyParam,EmptyParam);
 except
  w1.Disconnect;
 end;
end;

end.
